 processor 6502
 include "vcs.h"
 include "macro.h"
 include "2600basic.h"
 include "2600basic_variable_redefs.h"

 ORG $F000
; This is a 2-line kernel!
kernel
 lda bally
 sta stack2
 lda #1
 sta VDELBL
 sta VDELP0
 ldx missile1height
 inx
 sta WSYNC
 inx
 stx stack1
 ldx #0
 lda #4
 stx GRP0
 stx GRP1
 stx PF1
 stx PF2
 stx CXCLR
 sta temp4 ; pointer to PF gfx

 lda player0y ;store these so they can be retrieved later
 sta temp2
 lda player1y
 sta temp3

 lda missile0y
 sta temp5
 lda missile1y
 sta temp6

 lda playfieldpos
 sta temp1

 
 jmp .startkernel

.skipDrawP0
 sleep 2
 lda #0
 jmp .continueP0

.skipDrawP1
 sleep 2
 lda #0
 jmp .continueP1

.kerloop ; enter at cycle 59??
 
 ;missile/ball? 
 ldy playfield,x ;4
 sty PF1 ;3
 ldy playfield+1,x ;4
 sty PF2 ;3
 ldy playfield+3,x ;4
 sty PF1 ; 3 too early?
 ldy playfield+2,x;4
 sty PF2 ;3

; tya
goback
 dcp bally
; sleep 4

; sbc stack3
 rol
 rol
 sta ENABL 
.startkernel
 lda player0height ;3
 dcp player0y ;5
 bcc .skipDrawP0 ;2
 ldy player0y ;3
 lda (player0pointer),y ;5; player0pointer must be selected carefully by the compiler
			; so it doesn't cross a page boundary!

.continueP0
 sta GRP0 ;3
 lda missile0height ;3
 dcp missile0y ;5
; sbc stack1
 ;c=1 active
; ldy temp4 ;3;playfield counter
; lda #0 ;14
; lax temp4
; adc #1 ;16
 rol;2
 rol;2
 sta ENAM0 ;3


 ;missile/ball? 
 lda playfield,x ;4
 sta PF1 ;3
 lda playfield+1,x ;4
 sta PF2 ;3
 lda playfield+3,x ;4
 sta PF1 ; 3 too early?
 lda playfield+2,x;4
 sta PF2 ;3
 
 dec temp1
 beq altkernel
; sleep 3

 lda player1height
 dcp player1y
 bcc .skipDrawP1
 ldy player1y
 lda (player1pointer),y
.continueP1
 sta GRP1


 lda missile1height ;3
 dcp missile1y ;5
 sbc stack1
 ;c=1 active
; lax temp4 ;3
; lda #0 ;14
; adc #1 ;16
; rol;2
; rol;2
 sta ENAM1 ;3
 lda ballheight

; sleep 3
; lda ballheight
 jmp .kerloop

; sleep 2
; dex
; bne .kerloop

; beq endkernel

altkernel

 lda player1height
 dcp player1y
 bcc .skipDrawaltP1
 ldy player1y
 lda (player1pointer),y
.continuealtP1
 sta GRP1

 lda missile1height ;3
 dcp missile1y ;5
 ;c=1 active
; ldy temp4 ;3
; lda #0 ;14
; adc #1 ;16
 sbc stack1
 sta ENAM1 ;3

; sleep 2

 lda #0
 sta PF1
 sta PF2

 ;sleep 3

 ;28 cycles to fix things
 ;minus 11=17

; lax temp4
; clc
 txa
 adc #4
 tax
 cmp #44
 bne skiplastkernelline
 lda #9
 sbc playfieldpos
 sta temp4
 lda.w ballheight
 jmp enterlastkernel
skiplastkernelline

 sta temp4
 lda #8
 sta temp1
 lda ballheight

 jmp goback

 ;align 256

.skipDrawaltP1
 sleep 2
 lda #0
 jmp .continuealtP1

.skipDrawlastP0
 sleep 2
 lda #0
 jmp .continuelastP0

.endkerloop ; enter at cycle 59??
 
 ;missile/ball? 
 ldy playfield,x ;4
 sty PF1 ;3
 ldy playfield+1,x ;4
 sty PF2 ;3
 ldy playfield+3,x ;4
 sty PF1 ; 3 too early?
 ldy playfield+2,x;4
 sty PF2 ;3

enterlastkernel
; tya
 dcp bally
; sleep 4

; sbc stack3
 rol
 rol
 sta ENABL 
 lda player0height ;3
 dcp player0y ;5
 bcc .skipDrawlastP0 ;2
 ldy player0y ;3
 lda (player0pointer),y ;5; player0pointer must be selected carefully by the compiler
			; so it doesn't cross a page boundary!

.continuelastP0
 sta GRP0 ;3
 lda missile0height ;3
 dcp missile0y ;5
; sbc stack1
 ;c=1 active
; ldy temp4 ;3;playfield counter
; lda #0 ;14
; lax temp4
; adc #1 ;16

 dec temp4
 beq endkernel
; sleep 3


 ;missile/ball? 
 ldy playfield,x ;4
 sty PF1 ;3
 ldy playfield+1,x ;4
 sty PF2 ;3
 ldy playfield+3,x ;4
 sty PF1 ; 3 too early?
 ldy playfield+2,x;4
 sty PF2 ;3

 rol;2
 rol;2
 sta ENAM0 ;3
 

 lda player1height
 dcp player1y
 bcc .skipDrawlastP1
 ldy player1y
 lda (player1pointer),y
.continuelastP1
 sta GRP1


 lda missile1height ;3
 dcp missile1y ;5
 sbc stack1
 ;c=1 active
; lax temp4 ;3
; lda #0 ;14
; adc #1 ;16
; rol;2
; rol;2
 sta ENAM1 ;3
 lda ballheight

; sleep 3
; lda ballheight
 jmp .endkerloop


.skipDrawlastP1
 sleep 2
 lda #0
 jmp .continuelastP1


endkernel
 ; 6 digit score routine
 lda #0
 sta PF1
 sta PF2
 
                STA WSYNC ;first one, need one more
;                LDA #0
 sta REFP0
 sta REFP1
                STA GRP0
                STA GRP1
 ;               STA PF1
   ;             STA PF2
 sta ENAM0
 sta ENAM1
 sta ENABL
 sta WSYNC
 sleep 2
                STA GRP0
                STA GRP1 ; seems to be needed because of vdel

                LDY #7
                STY temp1
        LDA #$03
        STA NUSIZ0
        STA NUSIZ1
        STA VDELP0
        STA VDELP1
        LDA #$F0
        STA HMP0
               LDA scorecolor 
                nop
                STA RESP0
                STA RESP1
                STA COLUP0
                STA COLUP1
;               STA HMCLR
                STA WSYNC; second one
                STA HMOVE

loop2
 ldy  temp1        ;+3  63  189
 lda  (scorepointers),y     ;+5  68  204
 sta  GRP0            ;+3  71  213      D1     --      --     --
 sta  WSYNC           ;go
 lda  (scorepointers+$2),y  ;+5   5   15
 sta  GRP1            ;+3   8   24      D1     D1      D2     --
 lda  (scorepointers+$4),y  ;+5  13   39
 sta  GRP0            ;+3  16   48      D3     D1      D2     D2
 lda  (scorepointers+$6),y  ;+5  21   63
 sta  temp4         ;+3  24   72
 lda  (scorepointers+$8),y  ;+5  29   87
 tax                  ;+2  31   93
 lda  (scorepointers+$A),y  ;+5  36  108
 tay                  ;+2  38  114
 lda  temp4         ;+3  41  123              !
 sta  GRP1            ;+3  44  132      D3     D3      D4     D2!
 stx  GRP0            ;+3  47  141      D5     D3!     D4     D4
 sty  GRP1            ;+3  50  150      D5     D5      D6     D4!
 sta  GRP0            ;+3  53  159      D4*    D5!     D6     D6
 dec  temp1        ;+5  58  174                             !
 bpl  loop2           ;+2  60  180
 
                STA WSYNC       ;JUST ADDED
                LDA #0   
               STA GRP0
                STA GRP1
        STA VDELP0
        STA VDELP1;do we need these
        STA NUSIZ0
        STA NUSIZ1

 lda temp2 ;restore variables that were obliterated by kernel
 sta player0y
 lda temp3
 sta player1y
 lda temp5
 sta missile0y
 lda temp6
 sta missile1y
 lda stack2
 sta bally

 lda #43
 sta TIM64T
 LDA #%01000010
 sta WSYNC
 STA VBLANK
 rts
start
 sei
 cld
 ldx #0
 txa
clearmem
 inx
 txs
 pha
 bne clearmem
 lda #8
 sta playfieldpos
 ldx #11
initscore
 lda #>scoretable
 sta scorepointers,x 
 dex
 lda #<scoretable
 sta scorepointers,x 
 dex
 bpl initscore
 lda #1
 sta CTRLPF
 ora INTIM
 sta rand
 jmp game
; playfield drawing routines
; you get a 32x12 bitmapped display in a single color :)
; 0-31 and 0-11
setuppointers
 stx temp2 ; store on.off.flip value
 tax ; put x-value in x 
 lsr
 lsr
 lsr ; divide x pos by 8 
 sta temp1
 tya
 asl
 asl ; multiply y pos by 4
 clc
 adc temp1 ; add them together to get actual memory location offset
 tay ; put the value in y
 lda temp2 ; restore on.off.flip value
 rts

pfread
;x=xvalue, y=yvalue, a=0,1,2
 jsr setuppointers
 lda setbyte,x
 and playfield,y
; beq readzero
; lda #1
; readzero
 rts

pfpixel
;x=xvalue, y=yvalue, a=0,1,2
 jsr setuppointers
 jmp plotpoint

pfhline
;x=xvalue, y=yvalue, a=0,1,2, temp3=endx
 jsr setuppointers
 jmp noinc
keepgoing
 inx
 txa
 and #7
 bne noinc
 iny
noinc
 jsr plotpoint
 cpx temp3
 bmi keepgoing
 rts

pfvline
;x=xvalue, y=yvalue, a=0,1,2, temp3=endx
 jsr setuppointers
 sty temp1 ; store memory location offset
 inc temp3 ; increase final x by 1 
 lda temp3
 asl
 asl ; multiply by 4
 clc
 adc temp1 ; add to original memory offset to get final offset
 sta temp3 ; store it
 ; right now, temp1=y=starting memory location, temp3=final
 ; x should equal original x value
keepgoingy
 jsr plotpoint
 iny
 iny
 iny
 iny
 cpy temp3
 bmi keepgoingy
 rts

plotpoint
 lda temp2 ; load on.off.flip value (0,1, or 2)
 beq pixelon  ; if "on" go to on
 lsr
 bcs pixeloff ; value is 1 if true
 lda playfield,y ; if here, it's "flip"
 eor setbyte,x
 sta playfield,y
 rts
pixelon
 lda playfield,y
 ora setbyte,x
 sta playfield,y
 rts
pixeloff
 lda setbyte,x
 eor #$ff
 and playfield,y
 sta playfield,y
 rts

setbyte
 .byte $80
 .byte $40
 .byte $20
 .byte $10
 .byte $08
 .byte $04
 .byte $02
 .byte $01
 .byte $01
 .byte $02
 .byte $04
 .byte $08
 .byte $10
 .byte $20
 .byte $40
 .byte $80
 .byte $80
 .byte $40
 .byte $20
 .byte $10
 .byte $08
 .byte $04
 .byte $02
 .byte $01
 .byte $01
 .byte $02
 .byte $04
 .byte $08
 .byte $10
 .byte $20
 .byte $40
 .byte $80

pfscroll ;(a=0 left, 1 right, 2 up, 4 down)
 bne notleft
;left
 ldx #48
leftloop
 lda playfield-1,x
 lsr
 rol playfield-2,x
 ror playfield-3,x
 rol playfield-4,x
 ror playfield-1,x
; txa
; sbx #4
 dex
 dex
 dex
 dex
 bne leftloop
 rts

notleft
 lsr
 bcc notright
;right

 ldx #48
rightloop
 lda playfield-4,x
 lsr
 rol playfield-3,x
 ror playfield-2,x
 rol playfield-1,x
 ror playfield-4,x
 txa
 dex
 dex
 dex
 dex
; sbx #4
; bne rightloop
 rts

notright
 lsr
 bcc notup
;up
 dec playfieldpos
 bne noshiftdown 
 lda #8
 sta playfieldpos
 ldx #4
wrapup
 lda playfield-1,x
 sta temp1-1,x
 dex
 bne wrapup

; ldx #0
up2
 lda playfield+4,x
 sta playfield,x
 lda playfield+5,x
 sta playfield+1,x
 lda playfield+6,x
 sta playfield+2,x
 lda playfield+7,x
 sta playfield+3,x

 inx
 inx
 inx
 inx
 cpx #44
 bne up2
 ldx #4
wrapup1
 lda temp1-1,x
 sta playfield+43,x
 dex
 bne wrapup1

 rts

notup
;down
 inc playfieldpos
 lda playfieldpos
 cmp #9
 bne noshiftdown 
 lda #1
 sta playfieldpos
 ldx #4
swapdown
 lda playfield+43,x
 sta temp1-1,x
 dex
 bne swapdown
 ldx #44
down2
 lda playfield-1,x
 sta playfield+3,x
 lda playfield-2,x
 sta playfield+2,x
 lda playfield-3,x
 sta playfield+1,x
 lda playfield-4,x
 sta playfield,x
; txa
; sbx #4
 dex
 dex
 dex
 dex
 bne down2

 ldx #4
swapdown1
 lda temp1-1,x
 sta playfield-1,x
 dex
 bne swapdown1

noshiftdown
 rts
 
;standard routines needed for pretty much all games
;read switches, joysticks, position sprites, set score pointers,
;call the kernel, etc.

;switch register
switchreset
 lda #1
 bit SWCHB
 rts

switchselect
 lda #2
 bit SWCHB
 rts

switchleftb
 lda #$40
 bit SWCHB
 rts

switchrightb
 lda #$80
 bit SWCHB
 rts

switchbw
 lda #8
 bit SWCHB
 rts

;joyx routines return Z=0 if joystick is pressed that direction, otherwise Z=1.
joy0up
 lda #$10
 bit SWCHA
 rts

joy0down
 lda #$20
 bit SWCHA
 rts 

joy0left
 lda #$40
 bit SWCHA
 rts 

joy0right
 lda #$80
 bit SWCHA
 rts 
 
joy0fire
 lda #$80
 bit INPT4
 rts


horpos
 sec
 sta WSYNC
rept
 sbc #15
 bcs rept
 eor #7
 asl
 asl
 asl
 asl
 sta RESP0,x
 sta HMP0,x
 sta WSYNC
 sta HMOVE
 sleep 24
 sta HMCLR
 rts
 
playerset ;x: 0=p0, 1=p0, 2=m0, 3=m1, 4=bl
; a=horpos
; y=verpos
 jsr horpos 
 sty objecty,x
 rts

randomize
 lda rand
 lsr
 bcc noeor
 eor #$B2
noeor
 sta rand
 rts

scorepointerset
 tax
 and #$0F
 asl
 asl
 asl
 adc #<scoretable
 tay
 txa
 and #$F0
 lsr
 adc #<scoretable
 tax
 rts
drawscreen
overscan
 lda INTIM ;wait for sync
 bne overscan
;do VSYNC
 lda #2
 sta WSYNC
 sta VSYNC
 STA WSYNC
 STA WSYNC
 LDA #0
 STA WSYNC
 STA VSYNC
 sta VBLANK
 lda #37
 sta TIM64T

; position player 0
 lda player0x
 ldx #0
 ldy player0y
 jsr playerset

; position player 1
 lda player1x
 ldx #1
 ldy player1y
 jsr playerset

; position missile 0
 lda missile0x
 ldx #2
 ldy missile0y
 jsr playerset

; position missile 1
 lda missile1x
 ldx #3
 ldy missile1y
 jsr playerset

; position ball
 lda ballx
 ldx #4
 ldy bally
 jsr playerset

;set score pointers
 lda score+2
 jsr scorepointerset
 sty scorepointers+10
 stx scorepointers+8
 lda score+1
 jsr scorepointerset
 sty scorepointers+6
 stx scorepointers+4
 lda score
 jsr scorepointerset
 sty scorepointers+2
 stx scorepointers

vblk
 LDA INTIM
 bne vblk
 jmp kernel

; Fixed point math routines - created by AtariAge member djmips
; some changes by Fred Quimby

;assignment from 8.8 to 4.4

Assign88to44:

      ; A(4.4) = A,X(8.8)

       stx temp1
       rol temp1
       asl
       rol temp1
       asl
       rol temp1
       asl
       rol temp1
       asl
       rts

;assignment from 4.4 to 8.8
;

Assign44to88:

      ; A,X(8.8) = A(4.4)

       sta temp1
       lda #0
       asl temp1
       sbc #0   ;
       eor #$ff ; do sign extend
       rol
       asl temp1
       rol
       asl temp1
       rol
       asl temp1
       rol
       stx temp1
       rts

;
;Addition/subtraction asm procedures:

;add/sub 8.8 to/from 4.4

Add88to44:

      ; A(4.4) = A,X(8.8) + Y(4.4)

       jsr Assign88to44
       sty temp1
       clc
       adc temp1
       rts

Sub88from44:

      ; A(4.4) = A,X(8.8) - Y(4.4)

       jsr Assign88to44
       sty temp1
       sec
       sbc temp1
       rts


Add44to88:

      ; A,X(8.8) = A,X(8.8) + Y(4.4)

       sta temp2
       stx temp3
       tya
       jsr Assign44to88
       clc
       sta temp1
       txa
       adc temp3
       tax
       lda temp1
       adc temp2
       rts


Sub44from88:

      ; A,X(8.8) = A,X(8.8) - Y(4.4)

       sta temp2
       stx temp3
       tya
       jsr Assign44to88
       sec
       sta temp1
       lda temp3
       stx temp3
       sbc temp3
       tax
       lda temp2
       sbc temp1
       rts

; y and a contain multiplicands, result in a

mul8
 sty temp1
 sta temp2
 lda #0
reptmul8
 lsr temp2
 bcc skipmul8
 clc
 adc temp1
;bcs donemul8 might save cycles?
skipmul8
;beq donemul8 might save cycles?
 asl temp1
 bne reptmul8
donemul8
 rts 

div8
 ; a=numerator y=denominator, result in y
 cpy #2
 bcc div8end;div by 0 = bad, div by 1=no calc needed, so bail out
 sta temp1
 tya
 ldy #$ff
div8loop
 sbc temp1
 iny
 bcs div8loop
div8end
 tya
 ; result in a
 rts
game
.L00 ;  set smartbranching on

.L01 ;  include fixed_point_math.asm

.L02 ;  include div_mul.asm

.L03 ;  dim missilex1  =  e

.L04 ;  dim missiley1  =  f

.L05 ;  dim missilex1vel  =  g

.L06 ;  dim missiley1vel  =  h

.L07 ;  dim mapNum  =  o

.L08 ;  rem initialize variables

.L09 ;  x  =  50  :  y  =  25  :  w  =  60  :  v  =  65  :  r  =  110  :  s  =  60  :  m  =  0  :  missilex1vel  =  0  :  missiley1vel  =  0  :  missiley1  =  0  :  missilex1  =  0  :  ballheight  =  2

	LDA #50
	STA x
	LDA #25
	STA y
	LDA #60
	STA w
	LDA #65
	STA v
	LDA #110
	STA r
	LDA #60
	STA s
	LDA #0
	STA m
	STA missilex1vel
	STA missiley1vel
	STA missiley1
	STA missilex1
	LDA #2
	STA ballheight
.L010 ;  COLUPF  =  194

	LDA #194
	STA COLUPF
.L011 ;  COLUBK  =  240

	LDA #240
	STA COLUBK
.L012 ;  COLUP0  =  38

	LDA #38
	STA COLUP0
.L013 ;  AUDV0  =  7  :  AUDF0  =  16

	LDA #7
	STA AUDV0
	LDA #16
	STA AUDF0
.L014 ;  scorecolor  =  2

	LDA #2
	STA scorecolor
.L015 ;  score  =  0

	LDA #$00
	STA score+2
	LDA #$00
	STA score+1
	LDA #$00
	STA score
.L016 ;  d  =  0

	LDA #0
	STA d
.L017 ;  NUSIZ0  =  $4

	LDA #$4
	STA NUSIZ0
.L018 ;  mapNum  =  0

	LDA #0
	STA mapNum
.L019 ;  a  =  0

	LDA #0
	STA a
.
 ; 

.NEXTLEVEL ; NEXTLEVEL if mapNum  =  4 then mapNum  =  0

	LDA mapNum
	CMP #4
     BNE .skipNEXTLEVEL
	LDA #0
	STA mapNum
.skipNEXTLEVEL
.
 ; 

.
 ; 

.L020 ;  pfhline 0 0 31 on  :  pfhline 0 10 31 on  :  pfvline 0 0 9 on  :  pfvline 31 0 9 on

	LDA #31
	STA temp3
	LDA #0
	LDY #0
	LDX #0
	jsr pfhline
	LDA #31
	STA temp3
	LDA #0
	LDY #10
	LDX #0
	jsr pfhline
	LDA #9
	STA temp3
	LDA #0
	LDY #0
	LDX #0
	jsr pfvline
	LDA #9
	STA temp3
	LDA #31
	LDY #0
	LDX #0
	jsr pfvline
.
 ; 

.L021 ;  on mapNum goto MAP1 MAP3 MAP4 MAP5

	LDA mapNum
	ASL
	TAX
	LDA .L021jumptable,x
	PHA
	INX
	LDA .L021jumptable,x
	PHA
	RTS
.L021jumptable
	.byte >(.MAP1-1)
	.byte <(.MAP1-1)
	.byte >(.MAP3-1)
	.byte <(.MAP3-1)
	.byte >(.MAP4-1)
	.byte <(.MAP4-1)
	.byte >(.MAP5-1)
	.byte <(.MAP5-1)
.L022 ;  goto 30

	JMP .30

.
 ; 

.mapOpen ; mapOpen on mapNum goto MAP1OPEN MAP3OPEN MAP4OPEN MAP5OPEN

	LDA mapNum
	ASL
	TAX
	LDA .mapOpenjumptable,x
	PHA
	INX
	LDA .mapOpenjumptable,x
	PHA
	RTS
.mapOpenjumptable
	.byte >(.MAP1OPEN-1)
	.byte <(.MAP1OPEN-1)
	.byte >(.MAP3OPEN-1)
	.byte <(.MAP3OPEN-1)
	.byte >(.MAP4OPEN-1)
	.byte <(.MAP4OPEN-1)
	.byte >(.MAP5OPEN-1)
	.byte <(.MAP5OPEN-1)
.L023 ;  goto 30

	JMP .30

.
 ; 

.MAP1OPEN ; MAP1OPEN pfhline 0 0 5 flip

	LDA #5
	STA temp3
	LDA #0
	LDY #0
	LDX #2
	jsr pfhline
.L024 ;  goto 30

	JMP .30

.
 ; 

.MAP1 ; MAP1 pfhline 2 9 4 flip  :  pfhline 4 7 6 flip  :  pfhline 4 6 6 flip

	LDA #4
	STA temp3
	LDA #2
	LDY #9
	LDX #2
	jsr pfhline
	LDA #6
	STA temp3
	LDA #4
	LDY #7
	LDX #2
	jsr pfhline
	LDA #6
	STA temp3
	LDA #4
	LDY #6
	LDX #2
	jsr pfhline
.L025 ;  pfhline 4 3 6 flip  :  pfhline 4 4 6 flip  :  pfhline 8 7 10 flip  :  pfhline 8 6 10 flip

	LDA #6
	STA temp3
	LDA #4
	LDY #3
	LDX #2
	jsr pfhline
	LDA #6
	STA temp3
	LDA #4
	LDY #4
	LDX #2
	jsr pfhline
	LDA #10
	STA temp3
	LDA #8
	LDY #7
	LDX #2
	jsr pfhline
	LDA #10
	STA temp3
	LDA #8
	LDY #6
	LDX #2
	jsr pfhline
.L026 ;  pfhline 8 3 10 flip  :  pfhline 8 4 10 flip :  pfhline 8 4 10 flip  :  pfhline 12 1 14 flip

	LDA #10
	STA temp3
	LDA #8
	LDY #3
	LDX #2
	jsr pfhline
	LDA #10
	STA temp3
	LDA #8
	LDY #4
	LDX #2
	jsr pfhline
	LDA #10
	STA temp3
	LDA #8
	LDY #4
	LDX #2
	jsr pfhline
	LDA #14
	STA temp3
	LDA #12
	LDY #1
	LDX #2
	jsr pfhline
.L027 ;  if !pfread ( 9 , 3 )  then x  =  35  :  y  =  55  :  r  =  110  :  s  =  60  :  w  =  40  :  v  =  20  :  goto 30 else goto NEXTLEVEL

	LDA #9
	LDY #3
	jsr pfread
	BEQ .skipL027
	LDA #35
	STA x
	LDA #55
	STA y
	LDA #110
	STA r
	LDA #60
	STA s
	LDA #40
	STA w
	LDA #20
	STA v
	JMP .30
	JMP .skipelse0
.skipL027
	JMP .NEXTLEVEL

.skipelse0
.
 ; 

.
 ; 

.MAP3OPEN ; MAP3OPEN pfhline 12 10 16 flip

	LDA #16
	STA temp3
	LDA #12
	LDY #10
	LDX #2
	jsr pfhline
.L028 ;  goto 30

	JMP .30

.
 ; 

.MAP3
 ; MAP3

.L029 ;  pfhline 2 9 4 flip  :  pfhline 4 7 6 flip  :  pfhline 4 6 6 flip

	LDA #4
	STA temp3
	LDA #2
	LDY #9
	LDX #2
	jsr pfhline
	LDA #6
	STA temp3
	LDA #4
	LDY #7
	LDX #2
	jsr pfhline
	LDA #6
	STA temp3
	LDA #4
	LDY #6
	LDX #2
	jsr pfhline
.L030 ;  pfhline 4 3 6 flip  :  pfhline 4 4 6 flip  :  pfhline 8 7 10 flip  :  pfhline 8 6 10 flip

	LDA #6
	STA temp3
	LDA #4
	LDY #3
	LDX #2
	jsr pfhline
	LDA #6
	STA temp3
	LDA #4
	LDY #4
	LDX #2
	jsr pfhline
	LDA #10
	STA temp3
	LDA #8
	LDY #7
	LDX #2
	jsr pfhline
	LDA #10
	STA temp3
	LDA #8
	LDY #6
	LDX #2
	jsr pfhline
.L031 ;  pfhline 8 3 10 flip  :  pfhline 8 4 10 flip :  pfhline 8 4 10 flip  :  pfhline 12 1 14 flip

	LDA #10
	STA temp3
	LDA #8
	LDY #3
	LDX #2
	jsr pfhline
	LDA #10
	STA temp3
	LDA #8
	LDY #4
	LDX #2
	jsr pfhline
	LDA #10
	STA temp3
	LDA #8
	LDY #4
	LDX #2
	jsr pfhline
	LDA #14
	STA temp3
	LDA #12
	LDY #1
	LDX #2
	jsr pfhline
.
 ; 

.
 ; 

.L032 ;  pfhline 1 2 2 flip

	LDA #2
	STA temp3
	LDA #1
	LDY #2
	LDX #2
	jsr pfhline
.L033 ;  pfhline 5 3 7 flip  :  pfhline 5 2 7 flip  :  pfvline 11 1 7 flip

	LDA #7
	STA temp3
	LDA #5
	LDY #3
	LDX #2
	jsr pfhline
	LDA #7
	STA temp3
	LDA #5
	LDY #2
	LDX #2
	jsr pfhline
	LDA #7
	STA temp3
	LDA #11
	LDY #1
	LDX #2
	jsr pfvline
.L034 ;  pfhline 5 5 7 flip  :  pfhline 5 6 7 flip  :  pfhline 5 8 7 flip  :  pfhline 5 9 7 flip  :  pfhline 11 8 13 flip  :  pfvline 14 8 1 flip

	LDA #7
	STA temp3
	LDA #5
	LDY #5
	LDX #2
	jsr pfhline
	LDA #7
	STA temp3
	LDA #5
	LDY #6
	LDX #2
	jsr pfhline
	LDA #7
	STA temp3
	LDA #5
	LDY #8
	LDX #2
	jsr pfhline
	LDA #7
	STA temp3
	LDA #5
	LDY #9
	LDX #2
	jsr pfhline
	LDA #13
	STA temp3
	LDA #11
	LDY #8
	LDX #2
	jsr pfhline
	LDA #1
	STA temp3
	LDA #14
	LDY #8
	LDX #2
	jsr pfvline
.L035 ;  pfpixel 11 4 off

	LDA #11
	LDY #4
	LDX #1
	jsr pfpixel
.L036 ;  if !pfread ( 6 , 5 )  then x  =  40  :  y  =  35  :  r  =  110  :  s  =  60  :  w  =  110  :  v  =  35  :  goto 30 else goto NEXTLEVEL

	LDA #6
	LDY #5
	jsr pfread
	BEQ .skipL036
	LDA #40
	STA x
	LDA #35
	STA y
	LDA #110
	STA r
	LDA #60
	STA s
	LDA #110
	STA w
	LDA #35
	STA v
	JMP .30
	JMP .skipelse1
.skipL036
	JMP .NEXTLEVEL

.skipelse1
.
 ; 

.
 ; 

.
 ; 

.MAP4OPEN ; MAP4OPEN pfhline 2 10 6 flip

	LDA #6
	STA temp3
	LDA #2
	LDY #10
	LDX #2
	jsr pfhline
.L037 ;  goto 30

	JMP .30

.
 ; 

.MAP4
 ; MAP4

.L038 ;  pfpixel 11 4 on

	LDA #11
	LDY #4
	LDX #0
	jsr pfpixel
.L039 ;  pfhline 1 2 2 flip

	LDA #2
	STA temp3
	LDA #1
	LDY #2
	LDX #2
	jsr pfhline
.L040 ;  pfhline 5 3 7 flip  :  pfhline 5 2 7 flip  :  pfvline 11 1 7 flip

	LDA #7
	STA temp3
	LDA #5
	LDY #3
	LDX #2
	jsr pfhline
	LDA #7
	STA temp3
	LDA #5
	LDY #2
	LDX #2
	jsr pfhline
	LDA #7
	STA temp3
	LDA #11
	LDY #1
	LDX #2
	jsr pfvline
.L041 ;  pfhline 5 5 7 flip  :  pfhline 5 6 7 flip  :  pfhline 5 8 7 flip  :  pfhline 5 9 7 flip  :  pfhline 11 8 13 flip  :  pfvline 14 8 1 flip

	LDA #7
	STA temp3
	LDA #5
	LDY #5
	LDX #2
	jsr pfhline
	LDA #7
	STA temp3
	LDA #5
	LDY #6
	LDX #2
	jsr pfhline
	LDA #7
	STA temp3
	LDA #5
	LDY #8
	LDX #2
	jsr pfhline
	LDA #7
	STA temp3
	LDA #5
	LDY #9
	LDX #2
	jsr pfhline
	LDA #13
	STA temp3
	LDA #11
	LDY #8
	LDX #2
	jsr pfhline
	LDA #1
	STA temp3
	LDA #14
	LDY #8
	LDX #2
	jsr pfvline
.
 ; 

.
 ; 

.L042 ;  pfhline 1 4 3 flip  :  pfvline 3 3 0 flip  :  pfhline 3 2 6 flip  :  pfhline 6 1 0 flip  :  pfhline 3 8 6 flip  :  pfhline 9 2 12 flip  :  pfhline 12 3 0 flip

	LDA #3
	STA temp3
	LDA #1
	LDY #4
	LDX #2
	jsr pfhline
	LDA #0
	STA temp3
	LDA #3
	LDY #3
	LDX #2
	jsr pfvline
	LDA #6
	STA temp3
	LDA #3
	LDY #2
	LDX #2
	jsr pfhline
	LDA #0
	STA temp3
	LDA #6
	LDY #1
	LDX #2
	jsr pfhline
	LDA #6
	STA temp3
	LDA #3
	LDY #8
	LDX #2
	jsr pfhline
	LDA #12
	STA temp3
	LDA #9
	LDY #2
	LDX #2
	jsr pfhline
	LDA #0
	STA temp3
	LDA #12
	LDY #3
	LDX #2
	jsr pfhline
.L043 ;  pfhline 12 6 14 flip  :  pfvline 15 1 4 flip  :  pfhline 9 8 12 flip  :  pfhline 12 7 0 flip  :  pfvline 3 7 0 flip  :  pfvline 9 9 0 flip

	LDA #14
	STA temp3
	LDA #12
	LDY #6
	LDX #2
	jsr pfhline
	LDA #4
	STA temp3
	LDA #15
	LDY #1
	LDX #2
	jsr pfvline
	LDA #12
	STA temp3
	LDA #9
	LDY #8
	LDX #2
	jsr pfhline
	LDA #0
	STA temp3
	LDA #12
	LDY #7
	LDX #2
	jsr pfhline
	LDA #0
	STA temp3
	LDA #3
	LDY #7
	LDX #2
	jsr pfvline
	LDA #0
	STA temp3
	LDA #9
	LDY #9
	LDX #2
	jsr pfvline
.L044 ;  pfpixel 6 1 off  :  pfpixel 15 4 off  :  pfpixel 15 5 off

	LDA #6
	LDY #1
	LDX #1
	jsr pfpixel
	LDA #15
	LDY #4
	LDX #1
	jsr pfpixel
	LDA #15
	LDY #5
	LDX #1
	jsr pfpixel
.L045 ;  if !pfread ( 10 , 8 )  then x  =  100  :  y  =  65  :  r  =  40  :  s  =  20  :  w  =  85  :  v  =  15  :  goto 30 else goto NEXTLEVEL

	LDA #10
	LDY #8
	jsr pfread
	BEQ .skipL045
	LDA #100
	STA x
	LDA #65
	STA y
	LDA #40
	STA r
	LDA #20
	STA s
	LDA #85
	STA w
	LDA #15
	STA v
	JMP .30
	JMP .skipelse2
.skipL045
	JMP .NEXTLEVEL

.skipelse2
.
 ; 

.
 ; 

.
 ; 

.MAP5OPEN ; MAP5OPEN pfhline 0 0 3 flip

	LDA #3
	STA temp3
	LDA #0
	LDY #0
	LDX #2
	jsr pfhline
.L046 ;  goto 30

	JMP .30

.
 ; 

.MAP5
 ; MAP5

.
 ; 

.L047 ;  pfpixel 6 1 on  :  pfpixel 15 4 on  :  pfpixel 15 5 on

	LDA #6
	LDY #1
	LDX #0
	jsr pfpixel
	LDA #15
	LDY #4
	LDX #0
	jsr pfpixel
	LDA #15
	LDY #5
	LDX #0
	jsr pfpixel
.L048 ;  pfhline 1 4 3 flip  :  pfvline 3 3 0 flip  :  pfhline 3 2 6 flip  :  pfhline 6 1 0 flip  :  pfhline 3 8 6 flip  :  pfhline 9 2 12 flip  :  pfhline 12 3 0 flip

	LDA #3
	STA temp3
	LDA #1
	LDY #4
	LDX #2
	jsr pfhline
	LDA #0
	STA temp3
	LDA #3
	LDY #3
	LDX #2
	jsr pfvline
	LDA #6
	STA temp3
	LDA #3
	LDY #2
	LDX #2
	jsr pfhline
	LDA #0
	STA temp3
	LDA #6
	LDY #1
	LDX #2
	jsr pfhline
	LDA #6
	STA temp3
	LDA #3
	LDY #8
	LDX #2
	jsr pfhline
	LDA #12
	STA temp3
	LDA #9
	LDY #2
	LDX #2
	jsr pfhline
	LDA #0
	STA temp3
	LDA #12
	LDY #3
	LDX #2
	jsr pfhline
.L049 ;  pfhline 12 6 14 flip  :  pfvline 15 1 4 flip  :  pfhline 9 8 12 flip  :  pfhline 12 7 0 flip  :  pfvline 3 7 0 flip  :  pfvline 9 9 0 flip

	LDA #14
	STA temp3
	LDA #12
	LDY #6
	LDX #2
	jsr pfhline
	LDA #4
	STA temp3
	LDA #15
	LDY #1
	LDX #2
	jsr pfvline
	LDA #12
	STA temp3
	LDA #9
	LDY #8
	LDX #2
	jsr pfhline
	LDA #0
	STA temp3
	LDA #12
	LDY #7
	LDX #2
	jsr pfhline
	LDA #0
	STA temp3
	LDA #3
	LDY #7
	LDX #2
	jsr pfvline
	LDA #0
	STA temp3
	LDA #9
	LDY #9
	LDX #2
	jsr pfvline
.
 ; 

.
 ; 

.L050 ;  pfvline 3 1 5 flip  :  pfhline 3 6 6 flip  :  pfvline 6 4 1 flip  :  pfhline 6 4 9 flip  :  pfvline 17 1 0 flip  :  pfvline 24 1 3 flip

	LDA #5
	STA temp3
	LDA #3
	LDY #1
	LDX #2
	jsr pfvline
	LDA #6
	STA temp3
	LDA #3
	LDY #6
	LDX #2
	jsr pfhline
	LDA #1
	STA temp3
	LDA #6
	LDY #4
	LDX #2
	jsr pfvline
	LDA #9
	STA temp3
	LDA #6
	LDY #4
	LDX #2
	jsr pfhline
	LDA #0
	STA temp3
	LDA #17
	LDY #1
	LDX #2
	jsr pfvline
	LDA #3
	STA temp3
	LDA #24
	LDY #1
	LDX #2
	jsr pfvline
.L051 ;  pfvline 9 2 1 flip  :  pfhline 9 2 17 flip  :  pfvline 12 4 1 flip  :  pfhline 15 6 17 flip  :  pfvline 17 7 0 flip  :  pfhline 17 1 23 flip

	LDA #1
	STA temp3
	LDA #9
	LDY #2
	LDX #2
	jsr pfvline
	LDA #17
	STA temp3
	LDA #9
	LDY #2
	LDX #2
	jsr pfhline
	LDA #1
	STA temp3
	LDA #12
	LDY #4
	LDX #2
	jsr pfvline
	LDA #17
	STA temp3
	LDA #15
	LDY #6
	LDX #2
	jsr pfhline
	LDA #0
	STA temp3
	LDA #17
	LDY #7
	LDX #2
	jsr pfvline
	LDA #23
	STA temp3
	LDA #17
	LDY #1
	LDX #2
	jsr pfhline
.L052 ;  pfhline 20 4 23 flip  :  pfvline 20 4 5 flip

	LDA #23
	STA temp3
	LDA #20
	LDY #4
	LDX #2
	jsr pfhline
	LDA #5
	STA temp3
	LDA #20
	LDY #4
	LDX #2
	jsr pfvline
.L053 ;  if !pfread ( 21 , 4 )  then x  =  105  :  y  =  25  :  r  =  90  :  s  =  70  :  w  =  38  :  v  =  70  :  goto 30 else goto NEXTLEVEL

	LDA #21
	LDY #4
	jsr pfread
	BEQ .skipL053
	LDA #105
	STA x
	LDA #25
	STA y
	LDA #90
	STA r
	LDA #70
	STA s
	LDA #38
	STA w
	LDA #70
	STA v
	JMP .30
	JMP .skipelse3
.skipL053
	JMP .NEXTLEVEL

.skipelse3
.
 ; 

.
 ; 

.30 ; 30 ballx  =  r  :  bally  =  s  :  player0x  =  x  :  player0y  =  y  :  missile1x  =  missilex1  :  missile1y  =  missiley1  :  COLUP0  =  158  :  COLUP1  =  66

	LDA r
	STA ballx
	LDA s
	STA bally
	LDA x
	STA player0x
	LDA y
	STA player0y
	LDA missilex1
	STA missile1x
	LDA missiley1
	STA missile1y
	LDA #158
	STA COLUP0
	LDA #66
	STA COLUP1
.L054 ;  on m goto faceup facedown faceright faceleft

	LDA m
	ASL
	TAX
	LDA .L054jumptable,x
	PHA
	INX
	LDA .L054jumptable,x
	PHA
	RTS
.L054jumptable
	.byte >(.faceup-1)
	.byte <(.faceup-1)
	.byte >(.facedown-1)
	.byte <(.facedown-1)
	.byte >(.faceright-1)
	.byte <(.faceright-1)
	.byte >(.faceleft-1)
	.byte <(.faceleft-1)
.faceup ; faceup player0:

	LDA #<playerfaceup_0

	STA player0pointer
	LDA #>playerfaceup_0

	STA player0pointer+1
	JMP .faceupjump0
 if (<*) > (<(*+8))
	repeat ($100-<*)
	nop
	repend
	endif
playerfaceup_0

	.byte 0
	.byte  %00001000
	.byte  %00010000
	.byte  %00111100
	.byte  %00011000
	.byte  %00011000
	.byte  %00111100
	.byte  %00011000
	.byte  %00011000

.faceupjump0
	LDA #8
	STA player0height
.L055 ;  goto 32

	JMP .32

.facedown ; facedown player0:

	LDA #<playerfacedown_0

	STA player0pointer
	LDA #>playerfacedown_0

	STA player0pointer+1
	JMP .facedownjump0
 if (<*) > (<(*+8))
	repeat ($100-<*)
	nop
	repend
	endif
playerfacedown_0

	.byte 0
	.byte  %00011000
	.byte  %00011000
	.byte  %00111100
	.byte  %00011000
	.byte  %00011000
	.byte  %00111100
	.byte  %00001000
	.byte  %00010000

.facedownjump0
	LDA #8
	STA player0height
.L056 ;  goto 32

	JMP .32

.faceleft ; faceleft player0:

	LDA #<playerfaceleft_0

	STA player0pointer
	LDA #>playerfaceleft_0

	STA player0pointer+1
	JMP .faceleftjump0
 if (<*) > (<(*+4))
	repeat ($100-<*)
	nop
	repend
	endif
playerfaceleft_0

	.byte 0
	.byte  %00100100
	.byte  %00111101
	.byte  %11111110
	.byte  %00100000

.faceleftjump0
	LDA #4
	STA player0height
.L057 ;  goto 32

	JMP .32

.faceright ; faceright player0:

	LDA #<playerfaceright_0

	STA player0pointer
	LDA #>playerfaceright_0

	STA player0pointer+1
	JMP .facerightjump0
 if (<*) > (<(*+4))
	repeat ($100-<*)
	nop
	repend
	endif
playerfaceright_0

	.byte 0
	.byte  %00100100
	.byte  %10111100
	.byte  %01111111
	.byte  %00000100

.facerightjump0
	LDA #4
	STA player0height
.32 ; 32 player1:

	LDA #<player32_1

	STA player1pointer
	LDA #>player32_1

	STA player1pointer+1
	JMP .32jump1
 if (<*) > (<(*+8))
	repeat ($100-<*)
	nop
	repend
	endif
player32_1

	.byte 0
	.byte  %00100100
	.byte  %00100100
	.byte  %00111100
	.byte  %00011000
	.byte  %00011000
	.byte  %01111110
	.byte  %11011010
	.byte  %00011010

.32jump1
	LDA #8
	STA player1height
.38 ; 38 player1x  =  w  :  player1y  =  v

	LDA w
	STA player1x
	LDA v
	STA player1y
.
 ; 

.40 ; 40 drawscreen

	jsr drawscreen
.L058 ;  if player1x  =  player0x  &&  missilex1  =  0 then 41 else 43

	LDA player1x
	CMP player0x
     BNE .skipL058
	LDA missilex1
	CMP #0
 if ((* - .41) < 128) && ((* - .41) > -128)
	BEQ .41
 else
	bne .0skip41
	jmp .41
.0skip41
 endif
.skipL058
	JMP .43

.skipelse4
.41 ; 41 if player0y  <  player1y then missilex1  =  player1x  :  missiley1  =  player1y  :  missiley1vel  =  255  :  missilex1vel  =  0 else 42

	LDA player0y
	CMP player1y
     BCS .skip41
	LDA player1x
	STA missilex1
	LDA player1y
	STA missiley1
	LDA #255
	STA missiley1vel
	LDA #0
	STA missilex1vel
.skip41
	JMP .42

.skipelse5
.42 ; 42 if player0y  >  player1y then missilex1  =  player1x  :  missiley1  =  player1y  :  missiley1vel  =  1  :  missilex1vel  =  0 else 43

	LDA player1y
	CMP player0y
     BCS .skip42
	LDA player1x
	STA missilex1
	LDA player1y
	STA missiley1
	LDA #1
	STA missiley1vel
	LDA #0
	STA missilex1vel
.skip42
	JMP .43

.skipelse6
.
 ; 

.43 ; 43 if player1y  =  player0y  &&  missilex1  =  0 then 44 else 46

	LDA player1y
	CMP player0y
     BNE .skip43
	LDA missilex1
	CMP #0
 if ((* - .44) < 128) && ((* - .44) > -128)
	BEQ .44
 else
	bne .1skip44
	jmp .44
.1skip44
 endif
.skip43
	JMP .46

.skipelse7
.44 ; 44 if player0x  <  player1x then missilex1  =  player1x  :  missiley1  =  player1y  :  missilex1vel  =  255  :  missiley1vel  =  0 else 45

	LDA player0x
	CMP player1x
     BCS .skip44
	LDA player1x
	STA missilex1
	LDA player1y
	STA missiley1
	LDA #255
	STA missilex1vel
	LDA #0
	STA missiley1vel
.skip44
	JMP .45

.skipelse8
.45 ; 45 if player0x  >  player1x then missilex1  =  player1x  :  missiley1  =  player1y  :  missilex1vel  =  1  :  missiley1vel  =  0 else 46

	LDA player1x
	CMP player0x
     BCS .skip45
	LDA player1x
	STA missilex1
	LDA player1y
	STA missiley1
	LDA #1
	STA missilex1vel
	LDA #0
	STA missiley1vel
.skip45
	JMP .46

.skipelse9
.
 ; 

.46 ; 46 if collision(missile1,player0) then score  =  score  -  1  :  missilex1  =  0  :  missiley1  =  0  :  missilex1vel  =  0  :  missiley1vel  =  0  :  d  =  1

	BIT CXM1P
	BPL .skip46
	SED
	SEC
	LDA score+2
	SBC #$01
	STA score+2
	LDA score+1
	SBC #$00
	STA score+1
	LDA score
	SBC #$00
	STA score
	CLD
	LDA #0
	STA missilex1
	STA missiley1
	STA missilex1vel
	STA missiley1vel
	LDA #1
	STA d
.skip46
.L059 ;  if d  =  1 then goto death else goto notdeath

	LDA d
	CMP #1
     BNE .skipL059
	JMP .death
	JMP .skipelse10
.skipL059
	JMP .notdeath

.skipelse10
.
 ; 

.death
 ; death

.L060 ;  COLUP0  =  64

	LDA #64
	STA COLUP0
.L061 ;  player0:

	LDA #<playerL061_0

	STA player0pointer
	LDA #>playerL061_0

	STA player0pointer+1
	JMP .L061jump0
 if (<*) > (<(*+6))
	repeat ($100-<*)
	nop
	repend
	endif
playerL061_0

	.byte 0
	.byte  %00000100
	.byte  %01111111
	.byte  %10000000
	.byte  %00010101
	.byte  %00000000
	.byte  %00010010

.L061jump0
	LDA #6
	STA player0height
.L062 ;  COLUBK  =  0

	LDA #0
	STA COLUBK
.L063 ;  if !joy0right  &&  !joy0left  &&  !joy0up  &&  !joy0down  &&  !joy0fire then goto 30 else d  =  0  :  COLUBK  =  240  :  COLUP0  =  38  :  goto NEXTLEVEL

	jsr joy0right
	BEQ .skipL063
	jsr joy0left
	BEQ .skip13then
	jsr joy0up
	BEQ .skip14then
	jsr joy0down
	BEQ .skip15then
	jsr joy0fire
	BEQ .skip16then
	JMP .30
	JMP .skipelse11
.skip16then
.skip15then
.skip14then
.skip13then
.skipL063
	LDA #0
	STA d
	LDA #240
	STA COLUBK
	LDA #38
	STA COLUP0
	JMP .NEXTLEVEL

.skipelse11
.
 ; 

.notdeath
 ; notdeath

.
 ; 

.L064 ;  if collision(missile1,playfield) then missilex1  =  0  :  missiley1  =  0

	BIT CXM1FB
	BPL .skipL064
	LDA #0
	STA missilex1
	STA missiley1
.skipL064
.L065 ;  if collision(ball,player0) then score  =  score  +  1  :  r  =  0  :  s  =  0  :  goto mapOpen

	BIT CXP0FB
	BVC .skipL065
	SED
	CLC
	LDA score+2
	ADC #$01
	STA score+2
	LDA score+1
	ADC #$00
	STA score+1
	LDA score
	ADC #$00
	STA score
	CLD
	LDA #0
	STA r
	STA s
	JMP .mapOpen

.skipL065
.L066 ;  if missilex1  >  166  ||  missilex1  <  14 then missilex1  =  0  :  missiley1  =  0  :  missilex1vel  =  0  :  missiley1vel  =  0

	LDA #166
	CMP missilex1
     BCS .skipL066
	LDA #0
	STA missilex1
	STA missiley1
	STA missilex1vel
	STA missiley1vel
.skipL066
	LDA missilex1
	CMP #14
     BCS .skip6OR
	LDA #0
	STA missilex1
	STA missiley1
	STA missilex1vel
	STA missiley1vel
.skip6OR
.L067 ;  if missiley1  >  88  ||  missiley1  <  0 then missilex1  =  0  :  missiley1  =  0  :  missilex1vel  =  0  :  missiley1vel  =  0

	LDA #88
	CMP missiley1
     BCS .skipL067
	LDA #0
	STA missilex1
	STA missiley1
	STA missilex1vel
	STA missiley1vel
.skipL067
	LDA missiley1
	CMP #0
     BCS .skip7OR
	LDA #0
	STA missilex1
	STA missiley1
	STA missilex1vel
	STA missiley1vel
.skip7OR
.
 ; 

.L068 ;  if joy0left  &&  !joy0right  &&  !joy0up  &&  !joy0down then x  =  x  -  1  :  m  =  3  :  goto branch

	jsr joy0left
	BNE .skipL068
	jsr joy0right
	BEQ .skip24then
	jsr joy0up
	BEQ .skip25then
	jsr joy0down
	BEQ .skip26then
	DEC x
	LDA #3
	STA m
	JMP .branch

.skip26then
.skip25then
.skip24then
.skipL068
.L069 ;  if joy0right  &&  !joy0left  &&  !joy0up  &&  !joy0down then x  =  x  +  1  :  m  =  2  :  goto branch

	jsr joy0right
	BNE .skipL069
	jsr joy0left
	BEQ .skip28then
	jsr joy0up
	BEQ .skip29then
	jsr joy0down
	BEQ .skip30then
	INC x
	LDA #2
	STA m
	JMP .branch

.skip30then
.skip29then
.skip28then
.skipL069
.L070 ;  if joy0up  &&  !joy0down  &&  !joy0left  &&  !joy0right then y  =  y  -  1  :  m  =  0  :  goto branch

	jsr joy0up
	BNE .skipL070
	jsr joy0down
	BEQ .skip32then
	jsr joy0left
	BEQ .skip33then
	jsr joy0right
	BEQ .skip34then
	DEC y
	LDA #0
	STA m
	JMP .branch

.skip34then
.skip33then
.skip32then
.skipL070
.L071 ;  if joy0down  &&  !joy0up  &&  !joy0left  &&  !joy0right then y  =  y  +  1  :  m  =  1  :  goto branch

	jsr joy0down
	BNE .skipL071
	jsr joy0up
	BEQ .skip36then
	jsr joy0left
	BEQ .skip37then
	jsr joy0right
	BEQ .skip38then
	INC y
	LDA #1
	STA m
	JMP .branch

.skip38then
.skip37then
.skip36then
.skipL071
.
 ; 

.branch ; branch on m goto 47 48 49 50

	LDA m
	ASL
	TAX
	LDA .branchjumptable,x
	PHA
	INX
	LDA .branchjumptable,x
	PHA
	RTS
.branchjumptable
	.byte >(.47-1)
	.byte <(.47-1)
	.byte >(.48-1)
	.byte <(.48-1)
	.byte >(.49-1)
	.byte <(.49-1)
	.byte >(.50-1)
	.byte <(.50-1)
.
 ; 

.47 ; 47 if collision(player0,playfield) then y  =  y  +  1  :  goto 51 else goto 51

	BIT CXP0FB
	BPL .skip47
	INC y
	JMP .51
	JMP .skipelse12
.skip47
	JMP .51

.skipelse12
.48 ; 48 if collision(player0,playfield) then y  =  y  -  1  :  goto 51 else goto 51

	BIT CXP0FB
	BPL .skip48
	DEC y
	JMP .51
	JMP .skipelse13
.skip48
	JMP .51

.skipelse13
.49 ; 49 if collision(player0,playfield) then x  =  x  -  1  :  goto 51 else goto 51

	BIT CXP0FB
	BPL .skip49
	DEC x
	JMP .51
	JMP .skipelse14
.skip49
	JMP .51

.skipelse14
.50 ; 50 if collision(player0,playfield) then x  =  x  +  1  :  goto 51 else goto 51

	BIT CXP0FB
	BPL .skip50
	INC x
	JMP .51
	JMP .skipelse15
.skip50
	JMP .51

.skipelse15
.
 ; 

.
 ; 

.51 ; 51 if x  >  165  ||  x  <  15 then mapNum  =  mapNum  +  1  :  goto NEXTLEVEL

	LDA #165
	CMP x
     BCS .skip51
	INC mapNum
	JMP .NEXTLEVEL

.skip51
	LDA x
	CMP #15
     BCS .skip20OR
	INC mapNum
	JMP .NEXTLEVEL

.skip20OR
.L072 ;  if y  <  10  ||  y  >  88 then mapNum  =  mapNum  +  1  :  goto NEXTLEVEL

	LDA y
	CMP #10
     BCS .skipL072
	INC mapNum
	JMP .NEXTLEVEL

.skipL072
	LDA y
	CMP #88
     BCC .skip21OR
	INC mapNum
	JMP .NEXTLEVEL

.skip21OR
.L073 ;  player0y  =  y  :  player0x  =  x

	LDA y
	STA player0y
	LDA x
	STA player0x
.L074 ;  missiley1  =  missiley1  +  missiley1vel  :  missilex1  =  missilex1  +  missilex1vel

	LDA missiley1
	CLC
	ADC missiley1vel
	STA missiley1
	LDA missilex1
	CLC
	ADC missilex1vel
	STA missilex1
.L075 ;  goto 30
	JMP .30
       echo "    ",[(scoretable - *)]d , "bytes of ROM space left")
 ifconst ROM2k
 ORG $F7AC
 else
 ORG $FFAC
 endif
scoretable
       .byte %00111100
       .byte %01100110
       .byte %01100110
       .byte %01100110
       .byte %01100110
       .byte %01100110
       .byte %01100110
       .byte %00111100

       .byte %01111110
       .byte %00011000
       .byte %00011000
       .byte %00011000
       .byte %00011000
       .byte %00111000
       .byte %00011000
       .byte %00001000

       .byte %01111110
       .byte %01100000
       .byte %01100000
       .byte %00111100
       .byte %00000110
       .byte %00000110
       .byte %01000110
       .byte %00111100

       .byte %00111100
       .byte %01000110
       .byte %00000110
       .byte %00000110
       .byte %00011100
       .byte %00000110
       .byte %01000110
       .byte %00111100

       .byte %00001100
       .byte %00001100
       .byte %01111110
       .byte %01001100
       .byte %01001100
       .byte %00101100
       .byte %00011100
       .byte %00001100

       .byte %00111100
       .byte %01000110
       .byte %00000110
       .byte %00000110
       .byte %00111100
       .byte %01100000
       .byte %01100000
       .byte %01111110

       .byte %00111100
       .byte %01100110
       .byte %01100110
       .byte %01100110
       .byte %01111100
       .byte %01100000
       .byte %01100010
       .byte %00111100

       .byte %00110000
       .byte %00110000
       .byte %00110000
       .byte %00011000
       .byte %00001100
       .byte %00000110
       .byte %01000010
       .byte %00111110

       .byte %00111100
       .byte %01100110
       .byte %01100110
       .byte %01100110
       .byte %00111100
       .byte %01100110
       .byte %01100110
       .byte %00111100

       .byte %00111100
       .byte %01000110
       .byte %00000110
       .byte %00111110
       .byte %01100110
       .byte %01100110
       .byte %01100110
       .byte %00111100 


 ifconst ROM2k
 ORG $F7FC
 else
 ORG $FFFC
 endif
 .word start
 .word start
